/* DIFFH - A diff frontend for output in HTML format.
 * Module:  INPUT (header)
 * Author:  Matt Giuca
 * Created: 6/2/06
 * Updated: 6/2/06
 *
 * Copyright (C) 2006 Matt Giuca <mattgiuca@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later 
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Module: INPUT (header) */

/* Function: read_diff_file
 * Takes an input stream, reads until the end-of-file, and returns a complete
 * UDiff structure with the file. Expects a universal diff file, or RCS/CVS
 * diff output, as a universal diff.
 * If errors are encountered, prints error message to stderr and returns
 * NULL.
 * Precond: instream must be a valid, readable stream.
 */
extern UDiff* read_diff_file(FILE* instream);

/* Function: free_udiff
 * Frees up all memory associated with a UDiff, including the diff itself.
 * This also frees all of the hunks linked to by the udiff.
 * Precond: The pointers in the structure must all point to memory allocated
 * with malloc, and must all be valid.
 */
extern void free_udiff(UDiff* diff);
